use board_shared::position::Position2d;
use board_shared::tile::{Digit, Operator, Tile};
use serde::{Deserialize, Serialize};

#[derive(Serialize, Deserialize)]
#[serde(remote = "Tile")]
pub enum TileRef {
    Digit(#[serde(with = "DigitRef")] Digit),
    Operator(#[serde(with = "OperatorRef")] Operator),
    Equals,
}

#[derive(Serialize, Deserialize)]
#[serde(remote = "Digit")]
pub struct DigitRef {
    pub value: i8,
    pub has_left_parenthesis: bool,
    pub has_right_parenthesis: bool,
}

#[derive(Serialize, Deserialize)]
#[serde(remote = "Operator")]
pub enum OperatorRef {
    Add,
    Subtract,
    Multiply,
    Divide,
}

#[derive(Serialize, Deserialize)]
#[serde(remote = "Position2d")]
pub struct Position2dRef {
    pub x: usize,
    pub y: usize,
}
